% Copyright (C) 2008-2011 - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Overview}
\label{section-itropt-overview}

In this section, we analyze optimization problems and 
define the associated vocabulary. We introduce level sets and 
separate local and global optimums. We emphasize the 
use of contour plots in the context of unconstrained
and constrained optimization. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Classification of optimization problems}
\label{introoptim-section-classification}

In this document, we consider optimization problems in which we try to minimize a cost function 
\begin{eqnarray}
\min_{\bx\in \RR^n}f(\bx)
\end{eqnarray} 
with or without constraints. 
Several properties of the problem to solve may be taken into account by 
the numerical algorithms:
\begin{itemize}
\item The unknown may be a vector of real or integer values. 
\item The number of unknowns may be small (from 1 to 10 - 100), medium (from 10 to 100 - 1 000) or 
large (from 1 000 - 10 000 and above), leading to dense or sparse linear systems.
\item There may be one or several cost functions (multi-objective optimization).
\item The cost function may be smooth or non-smooth. 
\item There may be constraints or no constraints.
\item The constraints may be bounds constraints, linear or non-linear constraints. 
\item The cost function can be linear, quadratic or a general non linear function. 
\end{itemize}

An overview of optimization problems is presented in figure \ref{optiProblems}. 
In this document, we will be concerned mainly with continuous parameters and 
problems with one objective function only.
From that point, smooth and nonsmooth problems require very different 
numerical methods. 
It is generally believed that equality constrained optimization 
problems are easier to solve than inequality constrainted problems. This 
is because computing the set of active constraints at optimum is a 
difficult problem.

The size of the problem, i.e. the number $n$ of parameters, is also of great
concern with respect to the design of optimization algorithms.
Obviously, the rate of convergence is of primary interest when the 
number of parameters is large. Algorithms which require $n$ iterations,
like BFGS's methods for example, will not be efficient if the number of 
iterations to perform is much less than $n$. Moreover, several algorithms (like Newton's 
method for example), require too much storage to be of a practical 
value when $n$ is so large that $n\times n$ matrices cannot be stored.
Fortunately, good algorithms such as conjugate gradient methods and BFGS with 
limited memory methods are specifically designed for this purpose.

\begin{figure}
\begin{center}
\includegraphics[width=20cm,angle=90]{introoptim/OptimizationProblems.pdf}
\caption{Classes of optimization problems}
\label{optiProblems}
\end{center}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{What is an optimization problem ?}
\label{introoptim-section-optimproblem}

In the current section, we present the basic vocabulary of 
optimization. 

Consider the following general constrained optimization problem.
\begin{eqnarray}
\label{introoptim-problem-generalconst1}
&&\min_{\bx \in \RR^n} f(\bx)\\
&s.t.&h_i(\bx) = 0, \qquad i=1,m', \\
&&h_i(\bx) \geq 0, \qquad i=m'+1,m.
\label{introoptim-problem-generalconst3}
\end{eqnarray}

The following list presents the name of all the variables in the optimization problem.
\begin{itemize}
\item The variables $\bx\in\RR^n$ can be called the \emph{unknowns}, the \emph{parameters}
or, sometimes, the \emph{decision variables}. This is because, in many
physical optimization problems, some parameters are constants (the gravity
constant for example) and only a limited number of parameters can be optimized.
\index{objective}
\index{cost}
\item The function $f : \RR^n \rightarrow \RR$ is called the \emph{objective}
function. Sometimes, we also call it the \emph{cost} function.
\index{constraints}
\item The number $m\geq 0$ is the number of \emph{constraints} and the functions $h$ are the 
\emph{constraints function}. More precisely The functions $\{h_i\}_{i=1,m'}$ are the 
equality constraints functions and $\{h_i\}_{i=m'+1,m}$ are inequality 
constraints functions. 
\end{itemize}

Some additionnal notations are used in optimization and the following list 
present the some of the most useful.
\begin{itemize}
\index{feasible}
\item A point which satisfies all the constraints is \emph{feasible}.
The set of points which are feasible is called the \emph{feasible set}.
Assume that $\bx\in\RR^n$ is a feasible point. Then the direction $\bp\in\RR^n$ 
is called a feasible direction if the point $\bx+\alpha\bp\in\RR^n$ is 
feasible for all $\alpha\in\RR$.
\index{gradient}
\item The gradient of the objective function is denoted by $\bg(\bx)\in\RR^n$ 
and is defined as 
\begin{eqnarray}
\bg(\bx)=\nabla f (\bx) = \left(\frac{\partial f}{\partial x_1} , \ldots , \frac{\partial f}{\partial x_n}\right)^T.
\end{eqnarray}
\index{Hessian matrix}
\item The \emph{Hessian} matrix is denoted by $H(\bx)$ and is defined as 
\begin{eqnarray}
H_{ij}(\bx)=(\nabla^2 f)_{ij} = \frac{\partial^2 f}{\partial x_i \partial x_j}.
\end{eqnarray}
If $f$ is twice differentiable, then the Hessian matrix is symetric by 
equality of mixed partial derivatives so that $H_{ij}=H_{ji}$.
\end{itemize}

The problem of finding a feasible point is the \emph{feasibility problem} and 
may be quite difficult itself. 

A subclass of optimization problems is the problem where the inequality constraints 
are made of bounds. The \emph{bound-constrained} optimization problem is 
the following,
\begin{eqnarray}
\label{introoptim-problem-boundsconstrained}
&&\min_{\bx \in \RR^n} f(\bx)\\
&s.t.&x_{i,L} \leq x_i \leq x_{i,U}, \qquad i=1,m. \\
\end{eqnarray}
where $\{x_{i,L}\}_{i=1,m}$ (resp. $\{x_{i,U}\}_{i=1,m}$) are the 
lower (resp. upper) bounds.
Many physical problems are associated with this kind of problem,
because physical parameters are generaly bounded.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Rosenbrock's function}
\index{Rosenbrock H.H.}
\label{introoptim-section-rosenbrockfun}

We now present a famous optimization problem, used in many demonstrations 
of optimization methods. We will use this example consistently 
thoughout this document and will analyze it with Scilab. 
Let us consider Rosenbrock's function \cite{citeulike:1903787} defined by 
\begin{eqnarray}
\label{introoptim-rosenbrock}
f(\bx) = 100(x_2 - x_1^2)^2 + (1-x_1)^2.
\end{eqnarray}
The classical starting point is $\bx_0=(-1.2,1)^T$ where the 
function value is $f(\bx_0) = 24.2$.
The global minimum of this function is $\bx^\star = (1 , 1)^T$ where the function 
value is $f(\bx^\star) = 0$.
The gradient is 
\begin{eqnarray}
\bg(\bx) 
&=& \left(
\begin{array}{c}
- 400 x_1 ( x_2 - x_1^2 )  -2 ( 1 - x_1 ) \\
200 ( x_2 - x_1^2 )
\end{array}
\right) \\
&=& \left(
\begin{array}{c}
400 x_1^3 - 400 x_1 x_2 + 2 x_1 - 2\\
-200 x_1^2 + 200 x_2
\end{array}
\right).
\end{eqnarray}
The Hessian matrix is 
\begin{eqnarray}
H(\bx) 
= \left(
\begin{array}{cc}
1200 x_1^2 - 400 x_2 + 2 & -400 x_1 \\
-400 x_1 & 200
\end{array}
\right).
\end{eqnarray}

The following \scifun{rosenbrock} function computes the 
function value \scivar{f}, the gradient \scivar{g} and the Hessian matrix \scivar{H} 
of Rosenbrock's function.
\lstset{language=scilabscript}
\begin{lstlisting}
function [f, g, H] = rosenbrock ( x )
  f = 100*(x(2)-x(1)^2)^2 + (1-x(1))^2
  g(1) = - 400*(x(2)-x(1)^2)*x(1) - 2*(1-x(1))
  g(2) = 200*(x(2)-x(1)^2)
  H(1,1) = 1200*x(1)^2 - 400*x(2) + 2
  H(1,2) = -400*x(1)
  H(2,1) = H(1,2)
  H(2,2) = 200
endfunction
\end{lstlisting}
It is safe to say that the most common practical optimization issue is related 
to a bad implementation of the objective function. Therefore, we must be 
extra careful when we develop an objective function and is derivatives.
In order to help ourselves, we can use the function values which were 
given previously. In the following session, we check that 
our implementation of Rosenbrock's function satisfies $f(\bx_0) = 24.2$ 
and $f(\bx^\star) = 0$. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->x0 = [-1.2 1.0]'
 x0  =
  - 1.2  
    1.   
-->f0 = rosenbrock ( x0 )
 f0  =
    24.2  
-->xopt = [1.0 1.0]'
 xopt  =
    1.  
    1.  
-->fopt = rosenbrock ( xopt )
 fopt  =
    0.  
\end{lstlisting}

Notice that we define the initial and final 
points \scivar{x0} and \scivar{xopt} as \emph{column} vectors (as opposed
to row vectors). Indeed, this is the natural orientation for Scilab, since 
this is in that order that Scilab stores the values internally (because 
Scilab was primarily developped so that it can access to the Fortran 
routines of Lapack). Hence, we will be consistently use that particular 
orientation in this document. In practice, this allows to avoid 
orientation problems and related bugs.

We must now check that the derivatives are correctly implemented 
in our \scifun{rosenbrock} function.
To do so, we may use a symbolic computation system, such as 
Maple \cite{WWWMapleSoft}, Mathematica \cite{WWWMathematica} 
or Maxima \cite{WWWMaxima}. An effective way of computing a 
symbolic derivative is to use the web tool Wolfram Alpha 
\cite{WWWWolframAlpha}, which can be convenient in simple cases.

Another form of cross-checking can be done by computing numerical
derivatives and checking against the derivatives computed by the \scifun{rosenbrock}
function.
Scilab provides one function for that purpose, the \scifun{derivative} function,
which is presented in figure \ref{fig-numderfuns}. For most practical uses, the \scifun{derivative}
function is extremely versatile, and this is why we will use it thoughout this 
document.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
\scifun{derivative} & numerical derivatives of a function.\\
& Manages arbitrary step size.\\
& Provides order 1, 2 or 4 finite difference formula (default order = 2).\\
& Computes Jacobian and Hessian matrices.\\
& Manages additionnal arguments of the function to derivate.\\
& Produces various shapes of the output matrices.\\
& Manages orthogonal basis change \scivar{Q}.\\
\hline
% \scifun{numdiff} & numerical derivatives of a function.\\
% & Manages arbitrary step size.\\
% & Provides order 1 finite difference formula.\\
% & Manages additionnal arguments of the function to derivate.\\
% \hline
\end{tabular}
\end{center}
\caption{The \scifun{derivative} function.}
\label{fig-numderfuns}
\end{figure}

In the following session, we check our exact derivatives
against the numerical derivatives produced by 
the \scifun{derivative} function. We can see that the results are 
very close to each other, in terms of relative error.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[ f , g , H ] = rosenbrock ( x0 )
 H  =
    1330.    480.  
    480.     200.  
 g  =
  - 215.6  
  - 88.    
 f  =
    24.2  
-->[gfd, Hfd]=derivative(rosenbrock, x0, H_form='blockmat')
 Hfd  =
    1330.    480.  
    480.     200.  
 gfd  =
  - 215.6  - 88.  
-->norm(g-gfd')/norm(g)
 ans  =
    6.314D-11  
-->norm(H-Hfd)/norm(H)
 ans  =
    7.716D-09  
\end{lstlisting}

It would require a whole chapter to analyse the effect of rounding 
errors on numerical derivatives. Hence, we will derive here simplified 
results which can be used in the context of optimization. 

The rule of thumb is that we should expect at most 8 significant digits
for an order 1 finite difference computation of the gradient with Scilab. 
This is because the machine precision associated with doubles is approximately
$\epsilon_M \approx 10^{-16}$, which corresponds approximately to 16 significant digits.
With an order 1 formula, an achievable absolute error is roughly $\sqrt{\epsilon_M}\approx 10^{-8}$. 
With an order 2 formula (the default for the \scifun{derivative} function), 
an achievable absolute error is roughly $\epsilon_M^{\frac{2}{3}}\approx 10^{-11}$. 

Hence, we are now confident that our implementation of 
the Rosenbrock function is bug-free.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Level sets}
\label{section-levelsets}

\index{level set}

Suppose that we are given function $f$ with $n$ variables $f(\bx)=f(x_1,\ldots,x_n)$.
For a given $\alpha\in\RR$, the equation
\begin{eqnarray}
f(\bx) \leq \alpha,
\end{eqnarray}
defines a set of points in $\RR^n$. 

\begin{definition}(\emph{Level set})
\label{def-levelsets}
Assume that the function $f$ has $n$ variables $f(\bx)=f(x_1,\ldots,x_n)$. 
For any real $\alpha$, the level set $\mathcal{L}(\alpha)$ is the set 
\begin{eqnarray}
\label{section-levelsetsdef}
\mathcal{L}(\alpha)  = \left\{ \bx\in \RR^n, \; f(\bx) \leq \alpha \right\}.
\end{eqnarray}
\end{definition}

Suppose that an algorithm is given an initial guess $\bx_0$ as 
the starting point of the numerical method. We shall always assume 
that the level set $\mathcal{L}(f(\bx_0))$ is bounded.

Now consider the function $f(x)=e^x$ where $x\in\RR$.
This function is bounded below ($e^x>0$) and stricly decreasing.
But its level set $\mathcal{L}(f(x))$ is unbounded whatever the choice of $x$ :
this is because the $\exp$ function is so that $e^x\rightarrow 0$ as 
$x\rightarrow -\infty$.

\index{Rosenbrock H.H.}
Let us plot several level sets of Rosenbrock's function. 
To do so, we can use the \scifun{contour}
function. One small issue is that the \scifun{contour} function 
expects a function which takes two variables \scivar{x1} and \scivar{x2} as input arguments.
In order to pass to \scifun{contour} a function 
with the expected header, we define the \scifun{rosenbrockC}
function, which takes the two separate variables \scivar{x1} and 
\scivar{x2} as input arguments. Then, it gathers the 
two parameters into one column vector and delegates the work to the 
\scifun{rosenbrock} function.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = rosenbrockC ( x1 , x2 )
  f = rosenbrock ( [x1,x2]' )
endfunction
\end{lstlisting}
We can finally call the \scifun{contour} function and draw 
various level sets of Rosenbrock's function.
\lstset{language=scilabscript}
\begin{lstlisting}
x1 = linspace ( -2 , 2 , 100 );
x2 = linspace ( -1 , 2 , 100 );
contour(x1, x2, rosenbrockC, [2 10 100 500 1000 2000] )
\end{lstlisting}
This produces the figure \ref{fig-introoptim-contourrosenbrock}.

\begin{figure}
\begin{center}
\includegraphics[width=15cm]{introoptim/rosenbrockcontour_global.pdf}
\end{center}
\caption{Contours of Rosenbrock's function.}
\label{fig-introoptim-contourrosenbrock}
\end{figure}

We can also create a 3D plot of Rosenbrock's function.
In order to use the \scifun{surf} function, we must define 
the auxiliary function \scifun{rosenbrockS}, which takes vectors 
of data as input arguments. 
\lstset{language=scilabscript}
\begin{lstlisting}
function f = rosenbrockS ( x1 , x2 )
  f = rosenbrock ( [ x1 x2 ] )
endfunction
\end{lstlisting}
The following statements allows to produce the plot 
presented in figure \ref{fig-introoptim-rosenbrock3D}.
Notice that we must transpose the output of \scifun{feval}
in order to feed \scifun{surf}. 
\lstset{language=scilabscript}
\begin{lstlisting}
x = linspace ( -2 , 2 , 20 );
y = linspace ( -1 , 2 , 20 );
Z = feval ( x , y , rosenbrockS );
surf(x,y,Z')
h = gcf();
cmap=graycolormap(10);
h.color_map = cmap;
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=15cm]{introoptim/rosenbrock3D_global.pdf}
\end{center}
\caption{Three dimensionnal plot of Rosenbrock's function.}
\label{fig-introoptim-rosenbrock3D}
\end{figure}

On one hand, the 3D plot seems to be more informative than the contour 
plot. On the other hand, we see that the level sets of the 
contour plot follow the curve quadratic curve $x_2 = x_1^2$, as 
expected from the function definition. The surface has 
the shape of a valley, which minimum is at $\bx^\star = (1 , 1)^T$. 
The whole picture has the form of a banana, which explains why some demonstrations 
of this test case present it as the banana function. 
As a matter of fact, the contour plot is often much more simple to analyze
than a 3d surface plot. This is the reason why it is used more often 
in an optimization context, and particularily in this document.
Still, for more than two parameters, no contour plot can be drawn. 
Therefore, when the objective function depends on more than two parameters,
it is not easy to represent ourselves its associated landscape.

Although this is not an issue in most cases, it might happen that 
the performance might be a problem to create the contour plot.  
In this case, we can rely on the vectorization features of 
Scilab, which allows to greatly improve the speed of the 
creation of the computations.

In the following script, we create a \scifun{rosenbrockV} 
function which is a vectorized version of the Rosenbrock function. 
It takes the m-by-n matrices \scivar{x1} and \scivar{x2} as input arguments 
and returns the m-by-n matrix \scivar{f} which contains all the required 
function values. 
We use of the elementwise operators \scivar{.*} and \scivar{.\^}, 
which apply to a matrix of values element-by-element operations. 
Then we use the \scifun{meshgrid} function, which creates the two 
100-by-100 matrices \scivar{XX1} and \scivar{XX2}, containing combinations 
of the 1-by-100 matrices \scivar{x1} and \scivar{x2}.
This allows to compute the 100-by-100 matrix \scivar{Z} in one single 
call to the \scivar{rosenbrockV} function. 
Finally, we call the \scifun{contour} function which creates the same 
figure as previously. 
\lstset{language=scilabscript}
\begin{lstlisting}
function f = rosenbrockV ( x1 , x2 )
  f = 100 *(x2-x1.^2).^2 + (1-x1).^2
endfunction
x1 = linspace(-2,2,100); 
x2 = linspace(-2,2,100); 
[XX1,XX2]=meshgrid(x1,x2);
Z = rosenbrockV ( XX1 , XX2  );
contour ( x1 , x2 , Z' , [1 10 100 500 1000] );
\end{lstlisting}
The previous script is significantly faster than the previous versions. 
But it requires to rewrite the Rosenbrock function as a vectorized function, which 
can be impossible in some practical cases.

An elementary result about level sets is that the gradient at one point 
is perpendicular to the level set at this point \cite{wiki:levelset}.

\begin{proposition}
\emph{(Gradient and level sets)}
\label{propo-gradlevelset}
Let $f:\RR^n \rightarrow \RR$ be twice continously differentiable 
on an open set $S$ and let $\bx\in S$. 
Assume that $f(\bx)=\alpha$ and consider the level set $\mathcal{L}(\alpha)$ 
defined by \ref{section-levelsetsdef}.
Therefore, the gradient $\bg(\bx)$ is perpendicular to the level set $\mathcal{L}(\alpha)$.
\end{proposition}

\begin{proof}
The level set $\mathcal{L}(\alpha)$ can be parametrized by a function $\gamma$, 
where $\gamma(t)\in\mathcal{L}(\alpha)$ for any $t\in\RR$. 
Without loss of generality, assume that $t=0$ corresponds to the point $\bx$, 
that is, assume that $\gamma(0)=0$. 
By definition of the level set, we have 
\begin{eqnarray}
\label{eq-gradlevelset1}
f(\gamma(t)) = \alpha.
\end{eqnarray}
We can compute the derivative of the equation \ref{eq-gradlevelset1}, which implies 
\begin{eqnarray}
\label{eq-gradlevelset2}
\bg(\gamma(t))^T \gamma^\prime(t) = 0,
\end{eqnarray}
using the chain rule. 
The equation \ref{eq-gradlevelset2} is a scalar product between the 
row vector $\bg(\gamma(t))^T$ and the column vector $\gamma^\prime(t)$. 
The equation \ref{eq-gradlevelset2} states that the tangent to the level 
set $\gamma^\prime(t)$ is perpendicular to the gradient of the function $\bg(\gamma(t))$, 
which concludes the proof.
\end{proof}

\begin{figure}
\begin{center}
\includegraphics[width=5cm]{introoptim/gradientlevelset.pdf}
\end{center}
\caption{The gradient $\bg(\bx)$ at the point $\bx$ is perpendicular to the 
tangent $\gamma^\prime(t)$ of the level set $\mathcal{L}(\alpha)$.}
\label{fig-gradientlevelset}
\end{figure}

The exercise \ref{exer-gradlevelset} presents the case of a quadratic 
function.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{What is an optimum ?}
\label{introoptim-section-whatisoptimum}

In this section, we present the characteristics of the solution
of an optimization problem. The definitions presented in this 
section are mainly of theoretical value, and, in some sense,
of didactic value as well. More practical results will be presented later.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{introoptim/optimumtypes.pdf}
\end{center}
\caption{Different types of optimum -- strong local, weak local and strong global.}
\label{fig-introoptim-optimumtypes}
\end{figure}

There are three different types of minimum :
\begin{itemize}
\item strong local minimum,
\item weak local minimum,
\item strong global minimum.
\end{itemize}
These types of optimum are presented in figure \ref{fig-introoptim-optimumtypes}.

In order to define these different types of optimum more formally, 
we need to define the neighbourhood of a feasible point.
For any given feasible point $\bx\in\RR^n$, let us define $N(\bx,\delta)$ the set
of feasible points contained in a $\delta-$ neighbourhood of 
$\bx$. 

A $\delta-$ neighbourhood of $\bx$ is the ball centered at $\bx$ with radius $\delta$, 
\begin{eqnarray}
N(\bx,\delta) = \left\{\by\in\RR^n, \;\|\bx-\by\|\leq \delta\right\}.
\end{eqnarray}
The neighbourhood of a feasible point is presented in the 
figure \ref{fig-introoptim-neighbourhood}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{introoptim/neighbourhood.pdf}
\end{center}
\caption{Neighbourhood of a feasible point.}
\label{fig-introoptim-neighbourhood}
\end{figure}


\begin{definition}
\emph{(Strong local minimum)}
\index{strong local minimum}
The point $\bx^\star$ is a strong local minimum of the constrained 
optimization problem \ref{introoptim-problem-generalconst1}--\ref{introoptim-problem-generalconst3}
if there exists $\delta>0$ such that the two following conditions are satisfied :
\begin{itemize}
\item $f(\bx)$ is defined on $N(\bx^\star,\delta)$, 
\item $f(\bx^\star)<f(\by),\; \forall \by\in N(\bx^\star,\delta), \by\neq\bx^\star$.
\end{itemize}
\end{definition}

\begin{definition}
\emph{(Weak local minimum)}
\index{weak local minimum}
The point $\bx^\star$ is a weak local minimum of the constrained 
optimization problem \ref{introoptim-problem-generalconst1}--\ref{introoptim-problem-generalconst3}
if there exists $\delta>0$ such that the three following conditions are 
satisfied
\begin{itemize}
\item $f(\bx)$ is defined on $N(\bx^\star,\delta)$,
\item $f(\bx^\star)\leq f(\by),\; \forall \by\in N(\bx^\star,\delta)$,
\item $\bx^\star$ is not a strong local minimum.
\end{itemize}
\end{definition}

\begin{definition}
\emph{(Strong global minimum)}
\index{strong global minimum}
The point $\bx^\star$ is a strong global minimum of the constrained 
optimization problem \ref{introoptim-problem-generalconst1}--\ref{introoptim-problem-generalconst3}
if there exists $\delta>0$ such that the two following conditions are satisfied :
\begin{itemize}
\item $f(\bx)$ is defined on the set of feasible points,
\item $f(\bx^\star)<f(\by)$, for all $\by\in \RR^n$ feasible and $\by\neq\bx^\star$.
\end{itemize}
\end{definition}

Most algorithms presented in this document are searching for a strong local minimum.
The global minimum may be found in particular situations, for example when the 
cost function is convex. The difference between weak and strong local minimum
is also of very little practical use, since it is difficult to determine
what are the values of the function for all points except the computed 
point $\bx^\star$.

In practical situations, the previous definitions does not allow to 
get some insight about a specific point $\bx^\star$. This is why we 
will derive later in this document first order and second order necessary
conditions, which are computable characteristics of the optimum.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{An optimum in unconstrained optimization}

Before getting into the mathematics, we 
present some \emph{intuitive} results about unconstrained optimization.

Suppose that we want to solve the following unconstrained optimization problem.
\begin{eqnarray}
&&\min_{\bx \in \RR^n} f(\bx)
\end{eqnarray}
where $f$ is a smooth objective function. 
We suppose here that the hessian matrix is positive definite, i.e. its eigenvalues
are strictly positive.
This optimization problem is presented in figure \ref{fig-introoptim-unconst},
where the contours of the objective function are drawn.

\begin{figure}
\begin{center}
\includegraphics[width=5cm]{introoptim/fig-introoptim-unconst.pdf}
\caption{Unconstrained optimization problem with positive definite Hessian}
\label{fig-introoptim-unconst}
\end{center}
\end{figure}

The contours are the locations where the objective has a 
constant value. When the function is smooth and if we consider 
the behaviour of the function very near the optimum, the contours
are made of ellipsoids : when the ellipsoid is more elongated, the 
eigenvalues are of very different magnitude. This behaviour is the consequence 
of the fact that the objective function can be closely approximated, near the optimum,
by a quadratic function, as expected by the local Taylor expansion of the 
function. This quadratic function is closely associated with the Hessian 
matrix of the objective function.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Big and little O notations}
The proof of several results associated with optimality
require to make use of Taylor expansions.
Since the development of these expansions may require
to use the big and little O notations, this is the good place to 
remind ourselves the definition of the big and little o notations.

\begin{definition}{\emph{(Little o notation)}}
\label{def-littleo}
Assume that $p$ is a positive integer and $h$ is a function 
$h:\RR^n \rightarrow \RR$.

We have 
\begin{eqnarray}
\label{introoptim-eq-littleo}
h(\bx) = o(\|\bx\|^p)
\end{eqnarray}
if
\begin{eqnarray}
\label{introoptim-eq-littleolim}
\lim_{\bx\rightarrow 0} \frac{h(\bx)}{\|\bx\|^p} = 0.
\end{eqnarray}
\end{definition}

The previous definition intuitively means that 
$h(\bx)$ converges faster to zero than $\|\bx\|^p$.

\begin{definition}{\emph{(Big o notation)}}
\label{def-bigo}
Assume that $p$ is a positive integer and $h$ is a function 
$h:\RR^n \rightarrow \RR$.
We have 
\begin{eqnarray}
\label{introoptim-eq-bigo}
h(\bx) = O(\|\bx\|^p)
\end{eqnarray}
if there exists a finite number $M>0$, independent of $x$, 
and a real number $\delta > 0$ such that
\begin{eqnarray}
\label{introoptim-eq-bigobound}
|h(\bx)| \leq M \|\bx\|^p,
\end{eqnarray}
for all $\|\bx\| \leq \delta$.
\end{definition}

The equality \ref{introoptim-eq-bigo} therefore implies
that the rate at which $h(\bx)$ converges 
to zero increases as $p$ increases. 

\begin{example}
\label{examp-biglittleo}
Consider the polynomial
\begin{eqnarray}
\label{examp-biglittleo0}
h(x) = 2x^2 + 5x^3 - 4 x^4,
\end{eqnarray}
where $x\in^RR$.
If $|x|\leq 1$, then $|x|^3\leq x^2$ and $x^4\leq x^2$. 
Therefore,
\begin{eqnarray}
|h(x)| 
&\leq& 2|x^2| + 5|x^3| + 4 |x^4| \\
&\leq& 2x^2 + 5x^2 + 4 x^2 \\
&\leq& 11 x^2.
\label{examp-biglittleo1}
\end{eqnarray}
Hence, we can apply the definition \ref{def-bigo}, with 
$M=11$ and $\delta=1$.
This implies that $h(x)=O(|x|^2)$, or, more simply, 
$h(x)=O(x^2)$. 
This situation is presented in the figure \ref{fig-biogexample}.

\begin{figure}
\begin{center}
\includegraphics[width=15cm]{introoptim/bigOexample.pdf}
\end{center}
\caption{The function $h(x) = 2x^2 + 5x^3 - 4 x^4$ is so that $h(x)=O(x^2)$.}
\label{fig-biogexample}
\end{figure}


On the other hand, the inequality \ref{examp-biglittleo1} implies 
\begin{eqnarray}
\frac{|h(x)|}{|x|} \leq |x|,
\label{examp-biglittleo2}
\end{eqnarray}
if $x\neq 0$.
Hence, we can apply the definition \ref{def-littleo}, which 
implies that $h(x)=o(|x|)$.
\end{example}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Various Taylor expansions}
\index{Taylor expansions}

In this section, we will review various results which can be applied 
to continuously differentiable functions. These results are various 
forms of Taylor expansions which will be used throughout this 
document. We will not prove these propositions, which are topic 
of a general calculus course.

The following proposition makes use of the gradient of the function $f$.

\begin{proposition}
\emph{(Mean value theorem)}
\label{introoptim-propo-meanvaluetheorem}
Let $f:\RR^n \rightarrow \RR$ be continously differentiable
on an open set $S$ and let $\bx\in S$. 
Therefore, for all $\bp$ such that $\bx+\bp \in S$, there exists
an $\alpha \in[0,1]$ such that
\begin{eqnarray}
\label{introoptim-eq-meanvalue}
f(\bx+\bp) = f(\bx) + \bp^T \bg(\bx+\alpha\bp).
\end{eqnarray}
\end{proposition}

The following proposition makes use of the Hessian matrix of the function $f$.

\begin{proposition}
\emph{(Second order expansion)}
\label{introoptim-propo-secondorderexpansion}
Let $f:\RR^n \rightarrow \RR$ be twice continously differentiable 
on an open set $S$ and let $\bx\in S$. 
Therefore, for all $\bp$ such that $\bx+\bp \in S$, there exists
an $\alpha \in[0,1]$ such that
\begin{eqnarray}
\label{introoptim-eq-secondorderexp1}
f(\bx+\bp) = f(\bx) + \bp^T \bg(\bx) + \frac{1}{2} \bp^T H(\bx+\alpha\bp) \bp.
\end{eqnarray}
\end{proposition}

There is an alternative form of the second order expansion, which 
makes use of the $o(\cdot)$ or $O(\cdot)$ notations. 

\begin{proposition}
\emph{(Second order expansion - Second form)}
\label{introoptim-propo-secondorderexpansion2}
Let $f:\RR^n \rightarrow \RR$ be twice continously differentiable 
on an open set $S$ and let $\bx\in S$. 
Therefore, for all $\bp$ such that $\bx+\bp \in S$ 
\begin{eqnarray}
\label{introoptim-eq-secondorderexp2}
f(\bx+\bp) = f(\bx) + \bp^T \bg(\bx) + \frac{1}{2} \bp^T H(\bx) \bp + O(\|\bp\|^3).
\end{eqnarray}
\end{proposition}

The last term in the previous equation is often written 
as $o(\|\bp\|^2)$, which is equivalent.

\begin{example}
\label{examp-taylor}
Consider the polynomial
\begin{eqnarray}
\label{examp-taylor0}
h(x) = 2x^2 + 5x^3 - 4 x^4,
\end{eqnarray}
where $x\in\RR$.
Its first derivative is 
\begin{eqnarray}
\label{examp-taylor1}
h^\prime(x) = 4x + 15x^2 - 16x^3,
\end{eqnarray}
and its second derivative is
\begin{eqnarray}
\label{examp-taylor2}
h^{\prime \prime}(x) = 4 + 30x - 48x^2.
\end{eqnarray}
The proposition \ref{introoptim-propo-secondorderexpansion2} implies that 
the second order Taylor approximation is the function $t$ defined by 
\begin{eqnarray}
\label{examp-taylor3}
t(p) = h(x_0) + p h^\prime(x_0) + \frac{1}{2} p^2 h^{\prime \prime}(x_0) + O(|p|^3),
\end{eqnarray}
where $x_0\in\RR$ is a given point and $p\in\RR$. 
We consider the behavior of the function $h$ in the neighbourhood of the 
point $x_0=1$. 
Therefore, 
\begin{eqnarray}
\label{examp-taylor4}
h(x_0) &=& 3 \\
h^\prime(x_0) &=& 3\\
h^{\prime \prime}(x_0) &=& -14
\end{eqnarray}
Hence, in the neighbourhood of the point $x_0=1$, the function $h$ is 
approximated by the function
\begin{eqnarray}
\label{examp-taylor5}
t(p) = 3 + 3 p -7 p^2,
\end{eqnarray}
to order 2. 
A plot of the functions $h$ and $t$ is presented in the figure \ref{fig-taylorsec} 
for $x_0=1$.
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=15cm]{introoptim/taylorexample.pdf}
\end{center}
\caption{The function $h(x) = 2x^2 + 5x^3 - 4 x^4$ and its second order Taylor approximation 
at $x_0=1$, the polynomial $t(p) = 3 + 3 p -7 p^2$.}
\label{fig-taylorsec}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Notes and references}

The classification of optimization problems suggested 
in section \ref{introoptim-section-classification} is somewhat arbitrary.
Another classification, which focus on continuous variables is 
presented in \cite{BonnansGilbertLemarechalSagastizabal2002}, 
section 1.1.1, "Classification".

Most of the definitions of optimum in section 
\ref{introoptim-section-whatisoptimum} are extracted from Gill, Murray and Wright 
\cite{Gill81MurrayWright}, section 3.1, "Characterization of an optimum".
Notice that \cite{numericaloptimization} does not use the term \emph{strong}
local minimum, but use the term \emph{strict} instead.


The notations of section \ref{introoptim-section-optimproblem}
are generally used (see for example the chapter "Introduction" 
in \cite{numericaloptimization} or the chapter "Basic Concepts" in 
\cite{OtimizationKelley1999}).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{footnotesize}

\subsection{Exercises}
\label{section-itropt-exeroverview}

\begin{exercise}[Contours of quadratic functions]
\label{introoptim-exer-gradientquad}
Let us consider the following quadratic function 
\begin{eqnarray}
\label{introoptim-exer-gradientquad1}
f(\bx) = \bb^T \bx + \frac{1}{2} \bx^T H \bx,
\end{eqnarray}
where $\bx\in\RR^n$, the vector $\bb\in\RR^n$ is a given vector and 
$H$ is a definite positive symetric $n\times n$ matrix. Compute the gradient and the Hessian 
matrix of this quadratic function. Plot the contours of this function.
Consider the special case where
\begin{eqnarray}
\label{introoptim-exer-gradientquad1-bis}
H=\left(
\begin{array}{cc}
2 & 1\\
1 & 4
\end{array}\right)
\end{eqnarray}
and $\bb=(1,2)^T$.
Define a function which implements this function and draw its contours.
Use the function \scifun{derivative} and the point $\bx=(1,1)^T$ to check your result.
\end{exercise}

\begin{exercise}[Second order Taylor approximation]
\label{exer-taylorsec}
Consider the example \ref{examp-taylor}. 
Create the figure \ref{fig-taylorsec} with Scilab.
\end{exercise}

\begin{exercise}[Gradient and level set]
\label{exer-gradlevelset}
Consider the exercise \ref{introoptim-exer-gradientquad}. 
Compute the gradient at the points $\bx=(1,1)^T$, $(1,0.5)^T$, 
$(1,0)^T$, $(1,-0.5)^T$, $(1,-1)^T$ and $(1,-1.5)^T$.
On the same Scilab graphics, plot the contours and the normalize gradient 
vectors.
\end{exercise}

TODO : add the study of another function, Wood's ? 
TODO : add Powell's!

\end{footnotesize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\section{Convexity}
\label{introoptim-section-convexity}

In this section, we present the definition and properties of 
convex sets and convex functions. Convexity dominates the theory of optimization
and a lot of theoretical and practical optimization results can be established for these
mathematical objects.

We now give a motivation for the presentation of convexity in this 
document. In the current section, we present a proposition stating that 
there is an equivalence between the convexity of a function and the positivity of its associated 
Hessian matrix. Later in this document, we will prove that if a point is 
a local minimizer of a convex function, then it is also a global minimizer. 
This is not true for a general function: to see this, simply consider that a 
general function may have many local minimas. 
In practice, if we can prove that our particular unconstrained optimization 
problem is associated with a convex objective function, this particularily 
simplifies the problem, since any stationnary point is a global minimizer.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Convex sets}
\index{convex sets}

In this section, we present convex sets. 

We are going to analyse a very accurate definition of a convex set.
Intuitively, we can simply say that a set $C$ is convex if the line 
segment between any two points in $C$, lies in $C$.

\begin{definition}
\emph{(Convex set)}
A set $C$ in $\RR^n$ is convex if for every $\bx_1,\bx_2 \in C$
and every real number $\alpha$ so that $0\leq\alpha\leq1$, the point 
$\bx=\alpha\bx_1+(1-\alpha)\bx_2$ is in $C$. 
\end{definition}

Convex sets and nonconvex sets are presented in figure \ref{fig-introoptim-convexsets}.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/convexset-3examples.pdf}
\end{center}
\caption{Convex sets - The left set is convex. The middle set is not convex, because the segment
joining the two points is not inside the set. The right set is not convex
because parts of the edges of the rectangle are not inside the set.}
\label{fig-introoptim-convexsets}
\end{figure}

\index{convex combination}
A point $\bx\in\RR^n$ of the form $\bx=\theta_1\bx_1+\ldots+\theta_k\bx_k$
where $\theta_1+\ldots+\theta_k=1$ and $\theta_i\geq 0$, for $i=1,k$,
is called a convex combination of the points $\{\bx_i\}_{i=1,k}$ in the 
convex set $C$. A convex combination is indeed a weighted average of the points
$\{x_i\}_{i=1,k}$. It can be proved that a set is 
convex if and only if it contains all convex combinations of its points.

For a given set $C$, we can always define the \emph{convex hull}
of this set, by considering the following definition.

\index{convex hull}
\begin{definition}
\emph{(Convex hull)}
The \emph{convex hull} of $C$, denoted by $conv(C)$, is the set of 
all convex combinations of points in $C$:
\begin{eqnarray}
conv(C) = \left\{\theta_1\bx_1+\ldots+\theta_k\bx_k \;/\; \bx_i\in C,\;\theta_i\geq 0, i=1,k, 
\;\theta_1+\ldots+\theta_k=1\right\}
\end{eqnarray}
\end{definition}

Three examples of convex hulls are given in figure \ref{fig-introoptim-convexhull}.
The convex hull of a given set $C$ is convex.
Obviously, the convex hull of a convex set is the convex set itself, i.e.
$conv(C)=C$ if the set $C$ is convex.
The convex hull is the smallest convex set that contains $C$.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/convexhull-3examples.pdf}
\end{center}
\caption{Convex hull - The left set is the convex hull of a given number of 
points. The middle (resp. right) set is the convex set of the middle (resp. right) 
set in figure \ref{fig-introoptim-convexsets}. }
\label{fig-introoptim-convexhull}
\end{figure}

We conclude this section be defining a \emph{cone}.

\index{cone}
\begin{definition}
\emph{(Cone)}
A set $C$ is a cone if for every $\bx\in C$ and $\theta\geq 0$,
we have $\theta\bx\in C$.
\end{definition}

\index{convex cone}
A set $C$ is a \emph{convex cone} if it is convex and a cone, which 
means that for any $\bx_1,\bx_2\in C$ and $\theta_1,\theta_2\geq 0$,
we have 
\begin{eqnarray}
\theta_1 \bx_1 + \theta_2 \bx_2 \in C.
\end{eqnarray}

A cone is presented in figure \ref{fig-introoptim-cone}.

\begin{figure}
\begin{center}
\includegraphics[width=4cm]{introoptim/cone-example.pdf}
\end{center}
\caption{A cone}
\label{fig-introoptim-cone}
\end{figure}

An example of a cone which is nonconvex is presented in figure 
\ref{fig-introoptim-conenonconvex}. This cone is nonconvex because if 
we pick a point $\bx_1$ on the ray, and another point $\bx_2$ in the grey
area, there exists a $\theta$ with $0\leq \theta \leq 1$ so that a convex 
combination $\theta \bx_1 + (1-\theta) \bx_2$ is not in the set.

\begin{figure}
\begin{center}
\includegraphics[width=4cm]{introoptim/conenonconvex-example.pdf}
\end{center}
\caption{A nonconvex cone}
\label{fig-introoptim-conenonconvex}
\end{figure}

A \emph{conic combination} of points $\bx_1,\ldots,\bx_k\in C$ is 
a point of the form $\theta_1 \bx_1 + \ldots + \theta_k \bx_k$, with
$\theta_1,\ldots,\theta_k\geq 0$.

The \emph{conic hull} of a set $C$ is the set of all conic combinations of 
points in $C$, i.e.
\begin{eqnarray}
\left\{\theta_1 \bx_1 + \ldots + \theta_k \bx_k \; / \; \bx_i\in C, \; \theta_i\geq 0, \; i=1,k\right\}.
\end{eqnarray}
The conic hull is the smallest convex cone that contains $C$.

Conic hulls are presented in figure \ref{fig-introoptim-conichull}.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/conichull-2examples.pdf}
\end{center}
\caption{Conic hulls}
\label{fig-introoptim-conichull}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Convex functions}
\index{convex function}

\begin{definition}
\emph{(Convex function)}
A function $f:C\subset \RR^n\rightarrow \RR$ is convex if $C$ is a convex 
set and if, for all $\bx,\by\in C$, and for all $\theta$ with $0\leq \theta \leq 1$, we have
\begin{eqnarray}
\label{introoptim-ineqconvex}
f\left(\theta \bx + (1-\theta) \by\right) \leq \theta f(\bx) + (1-\theta)f(\by).
\end{eqnarray}
A function $f$ is strictly convex if the inequality \ref{introoptim-ineqconvex} is 
strict, when $\bx\neq \by$.
\end{definition}

\index{Jensen's inequality}
The inequality \ref{introoptim-ineqconvex} is sometimes called \emph{Jensen's inequality}
\cite{BoydVandenberghe2004}.
Geometrically, the convexity of the function $f$ means that the line segment between
$(\bx,f(\bx))$ and $(\by,f(\by))$ lies above the graph of $f$.
This situation is presented in figure \ref{fig-introoptim-convexfunction}.

Notice that the function $f$ is convex only if its domain of definition 
$C$ is a convex set. This topic will be reviewed later, when we will analyze 
a counter example of this.

\begin{figure}
\begin{center}
\includegraphics[width=7cm]{introoptim/convex-function.pdf}
\end{center}
\caption{Convex function}
\label{fig-introoptim-convexfunction}
\end{figure}

\index{concave}
A function $f$ is \emph{concave} if $-f$ is convex.
A concave function is presented in figure \ref{fig-introoptim-concavefunction}.

\begin{figure}
\begin{center}
\includegraphics[width=7cm]{introoptim/concave-function.pdf}
\end{center}
\caption{Concave function}
\label{fig-introoptim-concavefunction}
\end{figure}

An example of a nonconvex function is presented in figure \ref{fig-introoptim-nonconvexfunction},
where the function is neither convex, nor concave. We shall give 
a more accurate definition of this later, but it is obvious from the 
figure that the \emph{curvature} of the function changes.

\begin{figure}
\begin{center}
\includegraphics[width=7cm]{introoptim/nonconvex-function.pdf}
\end{center}
\caption{Nonconvex function}
\label{fig-introoptim-nonconvexfunction}
\end{figure}

We can prove that the sum of two convex functions is a convex function, 
and that the product of a convex function by a scalar $\alpha>0$ 
is a convex function (this is trivial).
The level sets of a convex function are convex.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{First order condition for convexity}

In this section, we will analyse the properties of differentiable
convex functions. The two first properties of differentiable convex 
functions are first-order conditions (i.e. makes use of $\nabla f = \bg$), 
while the third property is a second-order condition (i.e. makes use 
of the hessian matrix $H$ of $f$).

\begin{proposition}
\emph{(First order condition of differentiable convex function)}
\label{introoptim-propo-convexfirstorder}
Let $f$ be continously differentiable. Then $f$ is convex 
over a convex set $C$ if and only if 
\begin{eqnarray}
\label{introoptim-ineqfirstorderconv}
f(\by)\geq f(\bx) + \bg(\bx)^T (\by - \bx)
\end{eqnarray}
for all $\bx,\by \in C$.
\end{proposition}

The proposition says that the graph of a convex function is above a line 
which slope is equal to the first derivative of $f$.
The figure \ref{fig-introoptim-firstordercond} presents a graphical 
analysis of the proposition. 
The first order condition can be associated with the Taylor 
expansion at the point $\bx$. The proposition tells  
that the first order Taylor approximation is under the graph 
of $f$, i.e. from a \emph{local} approximation of $f$, we 
can deduce a \emph{global} behaviour of $f$.
As we shall see later, this makes convex as perfect function candidates 
for optimization.

\begin{figure}
\begin{center}
\includegraphics[width=6cm]{introoptim/convex-firstordercond.pdf}
\end{center}
\caption{First order condition on convex functions}
\label{fig-introoptim-firstordercond}
\end{figure}

\begin{proof}
In the first part of the proof, let us assume that $f$ is convex over the convex set $C$.
Let us prove that the inequality \ref{introoptim-ineqfirstorderconv} 
is satisfied.
Assume that $\bx,\by$ are two point in $C$. Let $\theta$ be  
a scalar such that $0< \theta \leq 1$ (notice that $\theta$ is 
chosen strictly positive).
Because $C$ is a convex set, the point $\theta \by + (1-\theta)\bx$ is 
in the set $C$. 

This point can be written as $\bx + \theta (\by - \bx)$.
The idea of the proof is to compute the value of $f$ at the two 
points $\bx + \theta (\by - \bx)$ and $\bx$, and to form the 
factor $\left(f(\bx + \theta (\by - \bx))  -  f(\bx)\right)/\theta$.
This fraction can be used to derive the inequality by making 
$\theta\rightarrow 0$, so that we let appear the dot product $\bg(\bx)^T (\by - \bx)$.
This situation is presented in figure \ref{fig-introoptim-prooffocond}.

\begin{figure}
\begin{center}
\includegraphics[width=8cm]{introoptim/convex-focondproof.pdf}
\end{center}
\caption{Proof of the first order condition on convex functions - part 1}
\label{fig-introoptim-prooffocond}
\end{figure}

By the convexity hypothesis of $f$, we deduce:
\begin{eqnarray}
f(\theta \by + (1-\theta)\bx) \leq \theta f(\by) + (1-\theta)f(\bx).
\end{eqnarray}
The left hand side can be written as $f(\by + \theta (\bx - \by))$ 
while the right hand side of the previous inequality can be written in the 
form $f(\bx) + \theta ( f(\by) - f(\bx))$.
This leads to the following inequality:
\begin{eqnarray}
f(\bx + \theta (\by - \bx)) \leq f(\bx) + \theta ( f(\by) - f(\bx)).
\end{eqnarray}
We move the term $f(\bx)$ to the left hand side, divide 
by $\theta>0$ and get the inequality:
\begin{eqnarray}
\frac { f(\bx + \theta (\by - \bx))  -  f(\bx)} { \theta} \leq  f(\by) - f(\bx).
\end{eqnarray}
We can take the limit as $\theta\rightarrow 0$ since, by 
hypothesis, the function $f$ is continuously differentiable. 
Therefore, 
\begin{eqnarray}
\bg(\bx)^T (\by - \bx) \leq  f(\by) - f(\bx),
\end{eqnarray}
which concludes the first part of the proof.

In the second part of the proof, let us assume that the function 
$f$ satisfies the inequality \ref{introoptim-ineqfirstorderconv}.
Let us prove that $f$ is convex.

Let $\by_1,\by_2$ be two points in $C$ and let $\theta$ be a scalar such that $0\leq \theta \leq 1$.
The idea is to use the inequality \ref{introoptim-ineqfirstorderconv}, with the  
carefully chosen point $\bx=\theta\by_1 + (1-\theta)\by_2$.
This idea is presented in figure \ref{fig-introoptim-prooffocond2}.

\begin{figure}
\begin{center}
\includegraphics[width=6cm]{introoptim/convex-focondproof2.pdf}
\end{center}
\caption{Proof of the first order condition on convex functions - part 2}
\label{fig-introoptim-prooffocond2}
\end{figure}

The first order condition \ref{introoptim-ineqfirstorderconv} at the 
two points $\by_1$ and $\by_2$ gives:
\begin{eqnarray}
f(\by_1)&\geq& f(\bx) + \bg(\bx)^T (\by_1 - \bx)\\
f(\by_2)&\geq& f(\bx) + \bg(\bx)^T (\by_2 - \bx)
\end{eqnarray}
We can form a convex combination of the two inequalities and get:
\begin{eqnarray}
\theta f(\by_1) + (1-\theta) f(\by_2) &\geq& \theta f(\bx) + (1-\theta) f(\bx) \\
&&+ \bg(\bx)^T \left( \theta (\by_1 - \bx) + (1-\theta) (\by_2 - \bx) \right).
\end{eqnarray}
The previous inequality can be simplified into:
\begin{eqnarray}
\theta f(\by_1) + (1-\theta) f(\by_2) &\geq& f(\bx) 
+ \bg(\bx)^T \left( \theta \by_1 + (1-\theta) \by_2 - \bx \right).
\end{eqnarray}
By hypothesis $\bx=\theta\by_1 + (1-\theta)\by_2$, so that the inequality can 
be simplified again and can be written as:
\begin{eqnarray}
\theta f(\by_1) + (1-\theta) f(\by_2) &\geq& f(\theta\by_1 + (1-\theta)\by_2),
\end{eqnarray}
which shows that the function $f$ is convex and concludes the proof. 
\end{proof}

We shall find another form of the first order condition for convexity 
with simple algebraic manipulations.
Indeed, the inequality \ref{introoptim-ineqfirstorderconv} can be 
written $\bg(\bx)^T (\by - \bx) \leq f(\by) - f(\bx)$.
Multiplying both terms by $-1$ yields 
\begin{eqnarray}
\label{introoptim-focondsub1}
\bg(\bx)^T (\bx - \by) \geq f(\bx) - f(\by).
\end{eqnarray}
If we interchange the role of $\bx$ and $\by$ in \ref{introoptim-focondsub1},
we get $\bg(\by)^T (\by - \bx) \geq f(\by) - f(\bx)$.
The left hand side can be transformed so that the term $\bx-\by$ appear
and we find that:
\begin{eqnarray}
\label{introoptim-focondsub2}
-\bg(\by)^T (\bx - \by) \geq f(\by) - f(\bx).
\end{eqnarray}
We can now take the sum of the two inequalities \ref{introoptim-focondsub1}
and \ref{introoptim-focondsub2} and finally get:
\begin{eqnarray}
\left(\bg(\bx)-\bg(\by)\right)^T (\bx - \by) \geq 0.
\end{eqnarray}

This last derivation proved one part of the following proposition.

\begin{proposition}
\emph{(First order condition of differentiable convex function - second form)}
\label{introoptim-prop-foconvsecond}
Let $f$ be continously differentiable. Then $f$ is convex 
over a convex set $C$ if and only if 
\begin{eqnarray}
\label{introoptim-ineqfirstorderconv2}
\left(\bg(\bx)-\bg(\by)\right)^T (\bx - \by) \geq 0
\end{eqnarray}
for all $\bx,\by \in C$.
\end{proposition}

The second part of the proof is given as an exercise.
The proof is based on an auxiliary function that we are going to describe 
in some detail.

Assume that $\bx,\by$ are two points in the convex set $C$.
Since $C$ is a convex set, the point $\bx + \theta (\by - \bx) = \theta \by + (1-\theta) \bx$
is also in $C$, for all $\theta$ so that $0\leq \theta\leq 1$.
Let us define the following function 
\begin{eqnarray}
\phi(\theta) = f(\bx + \theta (\by - \bx)),
\end{eqnarray}
for all $\theta$ so that $0\leq \theta\leq 1$.

The function $\phi$ should really be denoted by $\phi_{\bx,\by}$, because it 
actually depends on the two points $\bx,\by\in C$.
Despite this lack of accuracy, we will keep our current notation for simplicity reasons,
assuming that the points $\bx,\by\in C$ are kept constant..

By definition, the function $\phi$ is so that the two following equalities are satisfied:
\begin{eqnarray}
\phi(0) = f(\bx), \qquad \phi(1) = f(\by).
\end{eqnarray}

The function $f$ is convex over the convex set $C$ if and only if 
the function $\phi$ satisfies the following inequality
\begin{eqnarray}
\phi(\theta)\geq \theta \phi(1) + (1-\theta)\phi(0),
\end{eqnarray}
for all $\bx,\by\in C$ and for all $\theta$ so that $0\leq \theta\leq 1$. 
One can easily see that $f$ is convex if and only if the function $\phi$
is convex for all $\bx,\by\in C$.
The function $\phi$ is presented in figure \ref{fig-introoptim-graphphi}.

\begin{figure}
\begin{center}
\includegraphics[width=7cm]{introoptim/convex-functionphi.pdf}
\end{center}
\caption{The function $\phi$}
\label{fig-introoptim-graphphi}
\end{figure}

If the function $f$ is continously differentiable, then the function $\phi$ is 
continuously differentiable and its derivative is 
\begin{eqnarray}
\phi'(\theta) = \bg(\bx + \theta (\by - \bx))^T (\by-\bx).
\end{eqnarray}
The first order condition \ref{introoptim-ineqfirstorderconv2} is associated with the 
property that $\phi$ satisfies the inequality
\begin{eqnarray}
\label{introoptim-convexphiprime}
\phi'(t) - \phi'(s)\geq 0,
\end{eqnarray}
for all real values $s$ and $t$ so that $t\geq s$.
The inequality \ref{introoptim-convexphiprime} satisfied by $\phi'$
simply states that $\phi'$ is an \emph{increasing} function.

If $f$ is twice continuously differentiable, the next section will present 
a result stating that the second derivative of $f$ is positive.
If $f$ is twice continuously differentiable, so is $\phi$ and 
the inequality \ref{introoptim-convexphiprime} can be associated  
with a \emph{positive curvature} of $\phi$.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Second order condition for convexity}

In this section, we analyse the the second order condition
for a convex function, i.e. the condition on the Hessian of the 
function.

\begin{proposition}
\emph{(Second order condition of differentiable convex function)}
\label{prop-ineqsecondorderconv}
Let $f$ be twice continously differentiable on the open convex set $C$. 
Then $f$ is convex on $C$ if and only if 
the Hessian matrix of $f$ is positive definite on $C$.
\end{proposition}

For a univariate function on $\RR$, the condition simply reduces to 
$f''(x)\geq 0$, i.e. $f$ has a positive curvature and 
$f'$ is a nondecreasing function.
For a multivariate function on $\RR^n$, the condition
signifies that the Hessian matrix $H(\bx)$ has positive eigenvalues 
for all $\bx\in C$

Notice that the convex set is now assumed to be \emph{open}.
This is an technical assumption, which allows to derive a 
Taylor expansion of $f$ in the neighbourhood of a given point
in the convex set.

Since the proof is strongly associated with the optimality conditions 
of an unconstrained optimization problem, we shall derive it here.

\begin{proof}
We assume that the Hessian matrix is positive definite.
Let us prove that the function $f$ is convex.
Since $f$ is twice continuously differentiable, we can use the 
following Taylor expansion of $f$. By the proposition 
\ref{introoptim-propo-secondorderexpansion}, there exists 
a $\theta$ satisfying $0\leq \theta \leq 1$ so that 
\begin{eqnarray}
\label{introoptim-ineqsecondorderconv2}
f(\by) = f(\bx) + \bg(\bx^\star)^T (\by - \bx) 
+ \frac{1}{2}(\by - \bx)^T H(\bx + \theta(\by-\bx))(\by - \bx),
\end{eqnarray}
for any $\bx,\by\in C$. 
Since $H$ is positive definite, the scalar $(\by - \bx)^T H(\bx + \theta(\by-\bx))(\by - \bx)$
is positive, which leads to the inequality 
\begin{eqnarray}
f(\by) \geq f(\bx) + \bg(\bx^\star)^T (\by - \bx).
\end{eqnarray}
By proposition \ref{introoptim-propo-convexfirstorder}, this proves 
that $f$ is convex on $C$.

Assume that $f$ is convex on the convex set $C$ and let us prove 
that the Hessian matrix is positive definite.
We assume that the Hessian matrix is not 
positive definite and show that it leads to a contradiction. 
The hypothesis that the Hessian matrix is not positive definite
implies that there exists a point $\bx\in C$ vector $\bp \in C$ such
that $\bp^T H(\bx) \bp < 0$. 
Let us define $\by = \bx + \bp$.
By the proposition 
\ref{introoptim-propo-secondorderexpansion}, there exists 
a $\theta$ satisfying $0\leq \theta \leq 1$ so that 
the equality \ref{introoptim-ineqsecondorderconv2} holds. 
Since $C$ is open and $f$ is twice
continuously differentiable, this inequality is also 
true in a neighbourhood of $\bx$. More formaly, this 
implies that we can choose the vector $\bp$ to be small enough
such that $\bp^T H(\bx + \theta \bp) \bp < 0$ for any $\theta\in[0,1]$.
Therefore, the equality \ref{introoptim-ineqsecondorderconv2} 
implies 
\begin{eqnarray}
f(\by) < f(\bx) + \bg(\bx^\star)^T (\by - \bx).
\end{eqnarray}
By proposition \ref{introoptim-propo-convexfirstorder}, 
the previous inequality contradicts the hypothesis that 
$f$ is convex. Therefore, the Hessian matrix $H$ is 
positive definite, which concludes the proof.
\end{proof}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Examples of convex functions}
\label{introoptim-section-examplesconvexfuns}

In this section, we give several examples of univariate 
and multivariate convex functions. We also give an example 
of a nonconvex function which defines a convex set.

\begin{example}
Consider the quadratic function $f:\RR^n \rightarrow \RR$
given by 
\begin{eqnarray}
f(\bx) = f_0 + \bg^T \bx + \frac{1}{2} \bx^T A \bx,
\end{eqnarray}
where $f_0\in\RR$, $\bg\in\RR^n$ and $A\in\RR^{n\times n}$.
For any $\bx\in\RR^n$, the Hessian matrix $H(\bx)$ is equal to the matrix $A$. 
Therefore, the quadratic function $f$ is convex if and only if the matrix $A$ is positive definite.
The quadratic function $f$ is strictly convex if and only if the matrix $A$ is 
strictly positive definite. We will review quadratic functions in more depth 
in the next section.
\end{example}

There are many other examples of convex functions. Obviously, any linear function is convex. 
The $\exp(ax)$ function is convex on $\RR$, for any $a\in\RR$. 
The function $x^a$ is convex on $\RR$ for any $a>0$. The 
function $-\log(x)$ is convex on $\RR_{++}=\{x>0\}$.
The function $x\log(x)$ is convex on $\RR_{++}$. The following 
script produces the two plots presented in figure  
\ref{fig-introoptim-convexexample}.

\lstset{language=scilabscript}
\begin{lstlisting}
x = linspace ( -5 , 5 , 1000 );
plot ( x , exp(x) , "b-" )
plot ( x , x^2 , "g--" )
legend ( [ "exp(x)" "x^2"] )
//
x = linspace ( 0.1 , 3 , 1000 );
plot ( x , -log(x) , "b-" )
plot ( x , x.*log(x) , "g--" )
legend ( [ "-log(x)" "x*log(x)"] )
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=15cm]{introoptim/convex-example2.pdf}
\includegraphics[width=15cm]{introoptim/convex-example1.pdf}
\end{center}
\caption{Examples of convex functions.}
\label{fig-introoptim-convexexample}
\end{figure}

As seen in the proof of the proposition \ref{prop-ineqsecondorderconv},
the hypothesis that the domain of definition of $f$, denoted by $C$,
is convex cannot be dropped. For example, consider the 
function $f(x)=1/x^2$, defined on the set $C = \{x\in\RR, x\neq 0\}$. 
The second derivative of $f$ is positive, since $f''(x) = 6/x^4>0$. 
But $f$ is not a convex function since $C$ is not a convex set.

Finally, let us consider an example where the function $f$ can 
define a convex set without being convex itself.
Consider the bivariate function
\begin{eqnarray}
f(x_1,x_2) = x_1/(1+x_2^2),
\end{eqnarray}
for any $\bx=(x_1,x_2)^T\in\RR^2$
The set of points satisfying the equation $f(x_1,x_2)\geq 0$ is a convex set, since 
it simplifies to the equation $x_1\geq 0$. This inequality obviously 
defines a convex set (since the convex combination of two positive numbers
is a positive number). But the function $f$ is non-convex, as we are going to 
see. In order to see this, the most simple is to create a 
3D plot of the function.
The following script produces the 3D plot which is presented in the 
figure \ref{fig-introoptim-nonconvexboyd1}.
\lstset{language=scilabscript}
\begin{lstlisting}
function z = f ( x1 , x2 ) 
  z = x2./(1+x2^2)
endfunction
x = linspace ( -5,5,20);
y = linspace ( -5,5,20);
Z = (eval3d(f,x,y))';
surf(x,y,Z)
h = gcf();
cmap=graycolormap(10);
h.color_map = cmap;
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=13cm]{introoptim/nonconvexboyd_3D.pdf}
\end{center}
\caption{The non-convex function $f(x_1,x_2) = x_1/(1+x_2^2)$.}
\label{fig-introoptim-nonconvexboyd1}
\end{figure}
The 3D plot suggests to search for the nonconvexity of the 
function on the line $x_1=1$, for example. On this section of the curve,
we clearly see that the function is concave for $x_2=0$. 
This leads to the following Scilab 
session, where we define the two points $\ba=(1,-1)^T$ and $\bb=(1,1)^T$.
Then we check that the point $\bc=t\ba+(1-t)\bb$ is so that 
the inequality $f(\bc)>tf(\ba)+(1-t)f(\bb)$ holds for $t=0.5$.
\lstset{language=scilabscript}
\begin{lstlisting}
-->a = [1 ; -1];
-->b = [1 ; 1];
-->t = 0.5;
-->c = t*a + (1-t)*b;
-->fa = f(a(1),a(2));
-->fb = f(b(1),b(2));
-->fc = f(c(1),c(2));
-->[ fc t*fa+(1-t)*fb]
 ans  =
    1.    0.5  
\end{lstlisting}
Therefore, the function $f$ is nonconvex, although it defines a 
convex set.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Quadratic functions}
\label{introoptim-section-examplesquadratic}

In this section, we consider specific examples of quadratic 
functions and analyse the sign of their eigenvalues to 
see if a stationnary point exist and is a local minimum.

Let us consider the following quadratic function 
\begin{eqnarray}
\label{introoptim-quadraticmodel}
f(\bx) = \bb^T \bx + \frac{1}{2} \bx^T H \bx,
\end{eqnarray}
where $\bx\in\RR^n$, the vector $\bb\in\RR^n$ is a given vector and 
$H$ is a $n\times n$ matrix. 

In the following examples, we use the \scifun{spec} function which is presented 
in figure \ref{fig-introoptim-spec}. This function allows to compute the 
eigenvalues, i.e. the \emph{spectrum}, and the eigenvectors of a given 
matrix. This function allows to access to several Lapack routines which 
can take into account for symetric or non-symetric matrices. 

In the context of numerical optimization, we often compute the 
eigenvalues of the Hessian matrix $H$ of the objective function, which implies that 
we consider only real symetric matrices. In this case, the eigenvalues and 
the eigenvectors are real matrices (as opposed to complex matrices).

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
\scifun{spec} & Computes the eigenvalue and the eigenvectors.\\
\hline
\scivar{D=spec(A)} & Computes the eigenvalues \scivar{D} of \scivar{A}. \\
\scivar{[R,D]=spec(A)} & Computes the right eigenvectors \scivar{R} of \scivar{A}. \\
\hline
\end{tabular}
\end{center}
\caption{The \scifun{spec} function.}
\label{fig-introoptim-spec}
\end{figure}

\begin{example}
\emph{(A quadratic function for which the Hessian has positive eigenvalues.)}
Assume that $\bb=0$ and the Hessian matrix is 
\begin{eqnarray}
H=\left(\begin{array}{cc}5 & 3\\ 3 & 2\end{array}\right)
\end{eqnarray}
The eigenvalues are approximately equal to 
$(\lambda_1,\lambda_2)\approx (0.1458980,6.854102)$ and are both 
positive. Hence, this quadratic function is strictly convex.

The following script produces the 
contours of the corresponding quadratic function. 
This produces the plot presented in figure \ref{fig-introoptim-defpos}.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadraticdefpos ( x1 , x2 )
  x = [x1 x2]'
  H = [5 3; 3 2]
  f = x.' * H * x;
endfunction
x = linspace(-2,2,100);
y = linspace(-2,2,100);
contour ( x , y , quadraticdefpos , [0.3 2 5 10 20])
\end{lstlisting}

The ellipsoids are typical of a strong local optimum.

In the following session, we compute
the eigenvalues and the eigenvectors of the Hessian matrix.
The \scifun{spec} function is used to compute the eigenvectors
$R$ and the diagonal eigenvalues matrix $D$ such that $H = R^T D R$.
We can check that, because the matrix is symetric, the \scifun{spec}
function makes so that the eigenvectors are orthogonal and satisfy
the equality $R^T R = I$, where $I$ is the $n\times n$ identity matrix.
\lstset{language=scilabscript}
\begin{lstlisting}
-->H = [5 3; 3 2]
 H  =
    5.    3.  
    3.    2.  
-->[R , D] = spec(H)
 D  =
    0.1458980    0.        
    0.           6.854102  
 R  =
    0.5257311  - 0.8506508  
  - 0.8506508  - 0.5257311  
-->R.' * R
 ans  =
    1.    0.  
    0.    1.  
\end{lstlisting}
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/introoptim-contourdefpos.pdf}
\end{center}
\caption{Contour of a quadratic function -- The eigenvalues of the matrix are both positive.}
\label{fig-introoptim-defpos}
\end{figure}


\begin{example}
\emph{(A quadratic function for which the Hessian has both positive and negative eigenvalues.)}
Assume that $\bb=0$ and the Hessian matrix is 
\begin{eqnarray}
H=\left(\begin{array}{cc}3 & -1\\ -1 & -8\end{array}\right)
\end{eqnarray}
\index{saddle point}
The eigenvalues are approximately equal to 
$(\lambda_1,\lambda_2)\approx (-8.0901699,3.0901699)$ so that
the matrix is indefinite. Hence, this quadratic function is 
neither convex, nor concave. 
The following script produces the contours of the corresponding quadratic function. 
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadraticsaddle ( x1 , x2 )
  x = [x1 x2]'
  H = [3 -1; -1 -8]
  f = x.' * H * x;
endfunction
x = linspace(-2,2,100);
y = linspace(-2,2,100);
contour ( x , y , quadraticsaddle , ..
  [-20 -10 -5 -0.3 0.3 2 5 10])
\end{lstlisting}
The contour plot is presented in figure \ref{fig-introoptim-saddle3dcut}.

The following script allows to produce the 3D plot 
presented in figure \ref{fig-introoptim-saddle3d}.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadraticsaddle ( x1 , x2 )
  x = [x1' x2']'
  H = [3 -1; -1 -8]
  y = H * x
  n = size(y,"c")
  for i = 1 : n
    f(i) = x(:,i)' * y(:,i)
  end
endfunction
x = linspace(-2,2,20);
y = linspace(-2,2,20);
Z = (eval3d(quadraticsaddle,x,y))';
surf(x,y,Z)
h = gcf();
cmap=graycolormap(10)
h.color_map = cmap;
\end{lstlisting}

The contour is typical of a saddle point where the gradient is zero, but which 
is not a local minimum. Notice that the function is unbounded.
\end{example}


\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/introoptim-saddlecontourcut.pdf}
\end{center}
\caption{A saddle point -- contour plot with cuts along the eigenvectors. 
The Hessian matrix has one negative eigenvalue and one positive eigenvalue.
The function is quadratic along the eigenvectors directions.}
\label{fig-introoptim-saddle3dcut}
\end{figure}


\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/introoptim-saddle3d.pdf}
\end{center}
\caption{A saddle point -- 3D plot}
\label{fig-introoptim-saddle3d}
\end{figure}

\begin{example}
\emph{(A quadratic function for which the Hessian has a zero and a positive eigenvalue.)}
Assume that $\bb=0$ and the Hessian matrix is
\begin{eqnarray}
H=\left(\begin{array}{cc}4 & 2\\ 2 & 1\end{array}\right)
\end{eqnarray}
The eigenvalues are approximately equal to 
$(\lambda_1,\lambda_2)\approx (0,5)$ so that
the matrix is not positive definite, but is positive semi-definite. 
Hence, this quadratic function is convex (but not strictly convex).
The following script produces the contours of the corresponding quadratic function 
which are presented in the figure \ref{fig-introoptim-nodefzero}.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadraticindef ( x1 , x2 )
  x = [x1 x2]'
  H = [4 2; 2 1]
  f = x.' * H * x;
endfunction
x = linspace(-2,2,100);
y = linspace(-2,2,100);
contour ( x , y , quadraticindef , [0.3 2 5 10 20])
\end{lstlisting}
The contour is typical of a weak local optimum. Notice that the function
remains constant along the eigenvector corresponding with the 
zero eigenvalue.
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/introoptim-contournotdef.pdf}
\end{center}
\caption{Contour of a quadratic function -- One eigenvalue is zero, the other is positive.}
\label{fig-introoptim-nodefzero}
\end{figure}

\begin{example}
\emph{(Example where there is no stationnary point.)}
Assume that $\bb=(1, 0)^T$ and the Hessian matrix is
\begin{eqnarray}
H=\left(\begin{array}{cc}0 & 0\\ 0 & 1\end{array}\right)
\end{eqnarray}
The function can be simplified as $f(\bx)=x_1+\frac{1}{2} x_2^2$.
The gradient of the function is $\bg(\bx)=(1,x_2)^T$.
There is no stationnary point, which implies that the 
function is unbounded.
The following script produces the contours of the corresponding quadratic function 
which are presented in the figure \ref{fig-introoptim-incompat}.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadraticincomp ( x1 , x2 )
  x = [x1 x2]'
  H = [0 0;0 1]
  b = [1;0]
  f = x.'*b + x.' * H * x;
endfunction
x = linspace(-10,10,100);
y = linspace(-10,10,100);
contour ( x , y , quadraticincomp , [-10 -5 0 5 10 20])
\end{lstlisting}
\end{example}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/introoptim-contourincomp.pdf}
\end{center}
\caption{Contour of a quadratic function -- The linear system associated with a zero gradient is incompatible.}
\label{fig-introoptim-incompat}
\end{figure}

%TODO : linear equality constraints
%TODO : linear inequality constraints
%TODO : nonlinear equality constraints
%TODO : nonlinear inequality constraints




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Notes and references}

The section \ref{introoptim-section-convexity}, which focus on convex functions 
is inspired from "Convex Optimization" by Boyd and Vandenberghe 
\cite{BoydVandenberghe2004}, chapter 2, "Convex sets" and chapter 3, "Convex functions".
A complementary and vivid perspective is given by Stephen Boyd in a series of lectures
available in videos on the website of Stanford's University. 

Most of this section can also be found in "Convex Analysis and Optimization" by 
Bertsekas \cite{Bertsekas2003}, chapter 1, "Basic Convexity Concepts".

Some of the examples considered in the section 
\ref{introoptim-section-examplesconvexfuns} are presented in 
\cite{BoydVandenberghe2004}, section 3.1.5 "Examples".
The nonconvex function $f(x_1,x_2) = x_1/(1+x_2^2)$ presented in 
section \ref{introoptim-section-examplesconvexfuns}
is presented by Stephen Boyd in his Stanford lecture "Convex Optimization I", Lecture 5.

The quadratic functions from section \ref{introoptim-section-examplesquadratic} 
are presented more briefly in Gill, Murray and Wright \cite{Gill81MurrayWright}.

The book by Luenberger \cite{Luenberger1984} presents convex sets in 
Appendix B, "Convex sets" and presents convex functions 
in section 6.4, "Convex and concave functions".

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{footnotesize}
\subsection{Exercises}
\label{introoptim-section-exerconvexity}

\begin{exercise}[Convex hull - 1]
\label{introoptim-exer-convexhull1}
Prove that a set is convex if and only if it contains every 
convex combinations of its points.
\end{exercise}

\begin{exercise}[Convex hull - 2]
\label{introoptim-exer-convexhull2}
Prove that the convex hull is the smallest convex set that contains $C$.
\end{exercise}

\begin{exercise}[Convex function - 1]
\label{introoptim-exer-convexfun1}
Prove that the sum of two convex functions is a convex function.
\end{exercise}

\begin{exercise}[Convex function - 2]
\label{introoptim-exer-convexfun2}
Prove that the level sets of a convex function are convex.
\end{exercise}

\begin{exercise}[Convex function - 3]
\label{introoptim-exer-convexfun3}
This exercise is associated with the proposition \ref{introoptim-prop-foconvsecond},
which gives the second form of the first 
order condition of a differentiable convex function.
The first part of the proof has already be proved in this chapter and 
the exercise is based on the proof of the second part.
Let $f$ be continously differentiable on the convex set $C$. 
Prove that if $f$ satisfies the inequality 
\begin{eqnarray}
\left(\bg(\bx)-\bg(\by)\right)^T (\bx - \by) \geq 0
\end{eqnarray}
for all $\bx,\by \in C$, then $f$ is convex over the convex set $C$.
\end{exercise}

\begin{exercise}[Hessian of Rosenbrock's function]
\label{introoptim-exer-localconvexrosen}
We have seen in exercise \ref{introoptim-exer-gradientquad} that the 
Hessian matrix of a quadratic function $f(\bx) = \bb^T \bx + \frac{1}{2} \bx^T H \bx$
is simply the matrix $H$. In this case the proposition \ref{prop-ineqsecondorderconv} 
states that if the matrix $H$ is positive definite, then it is convex. On the other 
hand, for a general function, there might be some points where the Hessian matrix is 
positive definite and some other points where it is indefinite. Hence the Hessian positivity is 
only \emph{local}, as opposed to the global behaviour of a quadratic function. 
Consider Rosenbrock's function defined by the equation \ref{introoptim-rosenbrock}.
Use Scilab and prove that the Hessian matrix is positive definite at the point $\bx = (1,1)^T$. 
Check that it is indefinite at the point $\bx = (0,1)^T$. 
Make a random walk in the interval $[-2,2]\times[-1,2]$ and 
check that many points are associated with an indefinite Hessian matrix. 
\end{exercise}

\end{footnotesize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{footnotesize}
\newpage
\section{Answers to exercises}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Answers for section \ref{section-itropt-exeroverview}}

\begin{answer}{\ref{introoptim-exer-gradientquad}}{Contours of quadratic functions}
By differientiating the equation \ref{introoptim-exer-gradientquad1} with respect 
to $\bx$, we get
\begin{eqnarray}
\label{introoptim-exer-gradientquad2}
\bg(\bx) = \bb + \frac{1}{2} H \bx + \frac{1}{2} \bx^T H.
\end{eqnarray}
We have $\bx^T H = H^T \bx$. By hypothesis, the matrix $H$ is symetric, which 
implies that $H^T = H$. Hence, we have $\bx^T H = H \bx$. This allows to simplify 
the equation \ref{introoptim-exer-gradientquad2} into
\begin{eqnarray}
\label{introoptim-exer-gradientquad3}
\bg(\bx) = \bb + H \bx.
\end{eqnarray}
We can differentiate the gradient, so that the Hessian matrix is $H$.

The following function \scifun{quadratic} defines the required function
and returns its function value \scivar{f}, its gradient \scivar{g} and 
its Hessian matrix \scivar{H}.
\lstset{language=scilabscript}
\begin{lstlisting}
function [f,g,H] = quadratic ( x )
  H = [2 1;1 4]
  b = [1;2]
  f = b' * x + 0.5 * x' * H * x
  g = b + H * x
endfunction
\end{lstlisting}
The following script creates the contour plot which is presented in figure 
\ref{fig-answer-quadraticcontour}.
\lstset{language=scilabscript}
\begin{lstlisting}
function f = quadraticC ( x1 , x2 )
  f = quadratic ( [x1 x2]' )
endfunction
xdata = linspace(-2,2,100);
ydata = linspace(-2.5,1.5,100);
contour ( xdata , ydata , quadratic , [0.5 2 4 8 12] )
\end{lstlisting}

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/quadratic-exercise.pdf}
\end{center}
\caption{The contours of a quadratic function.}
\label{fig-answer-quadraticcontour}
\end{figure}

In the following session, we define the point \scivar{x} and 
compute the function value, the gradient and the Hessian matrix at 
this point. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->x = [
-->  1
-->  1
-->  ]
 x  =
    1.  
    1.  
-->[ f , g , H ] = quadratic ( x )
 H  =
    2.    1.  
    1.    4.  
 g  =
    4.  
    7.  
 f  =
 
    7.  
\end{lstlisting}
In order to check that the computations are correct, we 
use the \scifun{derivative} function.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[gfd, Hfd]=derivative(quadratic, x, H_form='blockmat')
 Hfd  =
    2.    1.  
    1.    4.  
 gfd  =
    4.    7.  
\end{lstlisting}
We finally compute the relative error between the computed 
gradient and Hessian and the finite difference formulas.
\lstset{language=scilabscript}
\begin{lstlisting}
-->norm(g-gfd')/norm(g)
 ans  =
    3.435D-12  
-->norm(H-Hfd)/norm(H)
 ans  =
    0.  
\end{lstlisting}
The relative error for the gradient indicates that there are approximately 12 
significant digits. Therefore, our gradient is accurate. The Hessian matrix is exact.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exer-taylorsec}}{Second order Taylor approximation}
Consider the example \ref{examp-taylor}. 
The following script defines the functions \scivar{mypoly}, \scivar{mypolyD} and
\scivar{mypolyDD} which compute the function and its first and second derivatives.
\lstset{language=scilabscript}
\begin{lstlisting}
function y = mypoly(x)
    y = 2*x.^2 + 5*x.^3 - 4 *x.^4
endfunction
function y = mypolyD(x)
    y = 4*x + 15*x.^2 - 16 *x.^3
endfunction
function y = mypolyDD(x)
    y = 4 + 30*x - 48 *x.^2
endfunction
\end{lstlisting}
The following script creates the figure \ref{fig-taylorsec} with Scilab. 
It uses evaluates the function in the neighbourhood of the point \scivar{x0=1}, 
with \scivar{x} in the interval $[0.5 1.5]$ and with \scivar{p} in the 
interval $[-0.5,0.5]$.
\lstset{language=scilabscript}
\begin{lstlisting}
N = 100;
x = linspace(0.5,1.5,N);
y = mypoly(x);
x0 = 1;
p = linspace(-0.5,0.5,N);
hx0 = mypoly(x0)
hpx0 = mypolyD(x0)
hppx0 = mypolyDD(x0)
yT = hx0 + hpx0.*p + 0.5 * hppx0.*p.^2;
plot(x,y,"b-")
plot(x0+p,yT,"r-")
legend(["2x^2+5x^3-4x^4" "Taylor 2nd Degree"]);
xtitle("Taylor formula","X","");
h = gcf();
h.children(1).children(1).legend_location="in_lower_right";
\end{lstlisting}
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exer-gradlevelset}}{Gradient and level set}
Consider the exercise \ref{introoptim-exer-gradientquad}. 
Compute the gradient at the points $\bx=(1,0.5)^T$, 
$(1,0)^T$, $(1,-0.5)^T$, $(1,-1)^T$ and $(1,-1.5)^T$. 
The contour plots have already been presented in the exercise \ref{introoptim-exer-gradientquad}.
The following script plots the normalized gradient vectors. 
In order to get a scaled plot, we set the \scivar{isoview} graphics handle to 
"on".
\lstset{language=scilabscript}
\begin{lstlisting}
for x2 = [0.5 0 -0.5 -1 -1.5]
    x = [1;x2];
    [ f , g , H ] = quadratic ( x );
    plot(x(1),x(2),"bo")
    v = g / norm(g);
    data = [x x+v];
    plot(data(1,:),data(2,:),"r-")
    plot(data(1,2),data(2,2),"k+")
end
h = gcf();
h.children.isoview="on";
\end{lstlisting}

The previous script produces the figure \ref{fig-answer-quadlevsetgrad}.

\begin{figure}
\begin{center}
\includegraphics[width=10cm]{introoptim/quadlevsetgrad.pdf}
\end{center}
\caption{The contours of a quadratic function and various normalized gradient vectors.}
\label{fig-answer-quadlevsetgrad}
\end{figure}

\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Answers for section \ref{introoptim-section-exerconvexity}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{answer}{\ref{introoptim-exer-convexhull1}}{Convex hull - 1}

Before really detailing the proof, we can detail an auxiliary
result, which will help us in the design of the proof.
We are going to prove that a convex combination of 2 points can be 
combined with a third point so that the result is a convex combination
of the 3 points.
Let us suppose that $C$ is a convex set et let us assume that three 
points $\bx_1,\bx_2,\bx_3$ are in $C$. 
Let us assume that $\overline{\bx}_2$ is a convex combination of 
$\bx_1$ and $\bx_2$, i.e. 
\begin{eqnarray}
\overline{\bx}_2 = \theta_2 \bx_1 + (1-\theta_2) \bx_2,
\end{eqnarray}
with $0\leq \theta_2 \leq 1$.
Let us define $\overline{\bx}_3$ as a convex combination of 
$\overline{\bx}_2$ and $\bx_3$, i.e.
\begin{eqnarray}
\overline{\bx}_3 = \theta_3 \overline{\bx}_2 + (1-\theta_3) \bx_3,
\end{eqnarray}
with $0\leq \theta_3 \leq 1$.
This situation is presented in \ref{fig-answer-convexcombination}.
We shall prove that $\overline{\bx}_3$ is a convex combination 
of $\bx_1,\bx_2,\bx_3$.
Indeed, we can develop the equation for $\overline{\bx}_3$ so that
all the points $\bx_1,\bx_2,\bx_3$ appear:
\begin{eqnarray}
\overline{\bx}_3 = \theta_3 \theta_2 \bx_1 + \theta_3 (1-\theta_2) \bx_2 + (1-\theta_3) \bx_3.
\end{eqnarray}
The weights of the convex combination are $\theta_3 \theta_2\geq 0$, $\theta_3 (1-\theta_2)\geq 0$ 
and $1-\theta_3\geq 0$. Their sum is equal to 1, as proved by the following computation:
\begin{eqnarray}
\theta_3 \theta_2 + \theta_3 (1-\theta_2) + 1-\theta_3 &=&  \theta_3 (\theta_2 + 1-\theta_2 ) + 1-\theta_3\\
&=& \theta_3 + 1-\theta_3\\
&=&1,
\end{eqnarray}
which concludes the proof.

\begin{figure}
\begin{center}
\includegraphics[width=5cm]{introoptim/convexhull-exercise1.pdf}
\end{center}
\caption{Convex combination of 3 points.}
\label{fig-answer-convexcombination}
\end{figure}

Let us prove that a set is convex if and only if it contains every 
convex combinations of its points.

It is direct to prove that a set which contains every convex combinations
of its points is convex. Indeed, such a set contains any convex combination
of two points, which implies that the set is convex.

Let us prove that a convex set is so that every convex combination of
its points is convex.
The proof can be done by induction on the number $k$ of points in the 
set $C$. The definition of the convex set $C$ implies that the proposition 
is true for $k=2$. Assume that the hypothesis is true for $k$ points,
and let us prove that every convex combination of $k+1$ points 
is in the set $C$. Let $\{\bx_i\}_{i=1,k+1}\in C$ and 
let $\{\theta_i\}_{i=1,k+1}\in \RR$ be positive scalars such that 
$\theta_1+\ldots+\theta_k+\theta_{k+1}=1$.
Let us prove that 
\begin{eqnarray}
\overline{x}_{k+1}=\theta_1 \bx_1 + \ldots +\theta_k \bx_k + \theta_{k+1} \bx_{k+1} \in C.
\end{eqnarray}
All the weights $\{\theta_i\}_{i=1,k+1}$ cannot be equal to 0, because they are positive
and their sum is 1.
Without loss of generality, suppose that $0<\theta_{k+1}<1$ (if not, simply reorder 
the points $\{\bx_i\}_{i=1,k+1}$). Therefore
$1-\theta_{k+1}>0$. Then let us write $\overline{x}_{k+1}$ in the following 
form 
\begin{eqnarray}
\overline{x}_{k+1}&=&(1-\theta_{k+1})\left(\frac{\theta_1}{1-\theta_{k+1}} \bx_1 + \ldots 
+\frac{\theta_k}{1-\theta_{k+1}} \bx_k \right) + \theta_{k+1} \bx_{k+1}\\
&=&(1-\theta_{k+1}) \overline{\bx}_k + \theta_{k+1} \bx_{k+1},
\end{eqnarray}
with
\begin{eqnarray}
\overline{\bx}_k = \frac{\theta_1}{1-\theta_{k+1}} \bx_1 + \ldots 
+\frac{\theta_k}{1-\theta_{k+1}} \bx_k.
\end{eqnarray}
The point $\overline{x}_{k+1}$ is a convex combination of $k$ points because 
the weights are all positive and their sum is equal to one :
\begin{eqnarray}
\frac{\theta_1}{1-\theta_{k+1}}  + \ldots 
+\frac{\theta_k}{1-\theta_{k+1}} &=& \frac{1}{1-\theta_{k+1}} \left(\theta_1 + \ldots +\theta_k\right)\\
&=& \frac{1-\theta_{k+1}}{1-\theta_{k+1}} \\
&=& 1.
\end{eqnarray}
Therefore $\overline{x}_{k+1}$ is a convex combination of two points 
which are in the set $C$, with weights $1-\theta_{k+1}$ and $\theta_{k+1}$.
Since $C$ is convex, that implies that $\overline{x}_{k+1}\in C$, which 
concludes the proof. 
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{introoptim-exer-convexhull2}}{Convex hull - 2}
Let us prove that the convex hull is the smallest convex set that contains $C$.

There is no particular difficulty in this proof since only definitions are 
involved.
We must prove that if $B$ is any convex set that contains $C$, then
$conv(C)\subseteq B$. The situation is presented in figure 
\ref{fig-answer-convexhull}.
Assume that $B$ is a convex set so that $C\subseteq B$.
Suppose that $\bx\in conv(C)$. We must prove that $\bx\in B$.
But definition of the convex hull, there exist points $\{\bx_i\}_{i=1,k}\in C$,
and there exist $\{\theta_i\}_{i=1,k}$ so that $\theta_i\geq 0$
and $\theta_1+\ldots+\theta_k=1$. Since the points $\{\bx_i\}_{i=1,k}$ 
are in $C$, and since, by hypothesis, $C\subseteq B$, therefore the points
$\{\bx_i\}_{i=1,k} \in B$. By hypothesis, $B$ is convex, therefore $\bx$,
which is a convex combination of points in $B$, is also in $B$, i.e. $\bx\in B$.


\begin{figure}
\begin{center}
\includegraphics[width=5cm]{introoptim/convexhull-exercise2.pdf}
\end{center}
\caption{The convex hull $conv(C)$ is the smallest convex set that contains 
$C$.}
\label{fig-answer-convexhull}
\end{figure}
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{introoptim-exer-convexfun1}}{Convex function - 1}
Let us prove that the sum of two convex functions is a convex function.
Assume that $f_1,f_2$ are two convex functions on the convex set $C$ 
and consider the sum of the two functions $f=f_1+f_2$.
Assume that $\bx_1,\bx_2\in C$.
The following inequality, where $\theta$ satisfies $0\leq \theta \leq 1$,
\begin{eqnarray}
f(\theta\bx + (1-\theta)\bx ) 
&=& f_(\theta\bx_1 + (1-\theta)\bx_2) + f_2(\theta\bx_1 + (1-\theta)\bx_2) \\
&\leq& \theta\left( f(\bx_1) + f_2(\bx_2)\right) + (1-\theta)\left( f(\bx_1) + f_2(\bx_2)\right),
\end{eqnarray}
concludes the proof. 
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{introoptim-exer-convexfun2}}{Convex function - 2}
Let us prove that the level sets of a convex function are convex.

Assume that $f$ is a convex function on the convex set $C\subset \RR^n$.
The $\alpha$ be a given real scalar and let us consider the 
level set associated with $\alpha$ is defined by 
$L(\alpha) = \left\{ \bx\in C, \; f(\bx) \leq \alpha \right\}$.
Let $\bx_1,\bx_2$ be two points in $L(\alpha)$, let $\theta$ be 
a scalar so that $0\leq \theta \leq 1$. Let us 
prove that $\bx=\theta\bx_1 + (1-\theta)\bx_2$ is in $L(\alpha)$,
i.e. let us prove that $f(\bx)\leq \alpha$. 
To do so, we compute $f(\bx)$ and use the convexity of 
$f$ to get
\begin{eqnarray}
f(\bx) & = & f\left(\theta\bx_1 + (1-\theta)\bx_2\right)\\
&\leq & \theta f(\bx_1) + (1-\theta) f(\bx_2).
\end{eqnarray}
We additionnally use the two inequalities $f(\bx_1)\leq \alpha$ and $f(\bx_2)\leq \alpha$ and obtain:
\begin{eqnarray}
f(\bx) &\leq & \theta \alpha + (1-\theta) \alpha \\
&\leq & \alpha,
\end{eqnarray}
which concludes the proof. 
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{introoptim-exer-convexfun3}}{Convex function - 3}
Let $f$ be continously differentiable on the convex set $C$.
Let us prove that if $f$ satisfies the inequality 
\begin{eqnarray}
\label{answertoexer-focondsecond}
\left(\bg(\bx)-\bg(\by)\right)^T (\bx - \by) \geq 0
\end{eqnarray}
for all $\bx,\by \in C$, then $f$ is convex over the convex set $C$.
This proof is given in a slightly more complex form in \cite{Allaire2005},
chapter 10 "Conditions d'optimalit\'e", section 10.1.2 "Diff\'erentiabilit\'e".

Assume that $\bx,\by$ are two points in the convex set $C$.
Since $C$ is a convex set, the point $\bx + \theta (\by - \bx) = \theta \by + (1-\theta) \bx$
is also in $C$, for all $\theta$ so that $0\leq \theta\leq 1$.
Let us define the following function 
\begin{eqnarray}
\label{answer-defphi}
\phi(\theta) = f(\bx + \theta (\by - \bx)),
\end{eqnarray}
for all $\theta$ so that $0\leq \theta\leq 1$.

The idea of the proof is based on the fact that 
the convexity of $\phi$ with respect to $\theta\in[0,1]$ 
is equivalent to the convexity of $f$ with respect to $\bx\in C$.
We will prove that 
\begin{eqnarray}
\label{anwsers-convexphiprime}
\phi'(t) - \phi'(s)\geq 0,
\end{eqnarray}
for all real values $s$ and $t$ so that $t\geq s$.
That inequality means that $\phi'$ is an increasing function,
which property is associated with a convex function.
Then we will integrate the inequality over well chosen ranges of $s$ and $t$ so that 
the convexity of $\phi$ appear. 

To prove the inequality \ref{anwsers-convexphiprime}, let us define two real values $s,t\in \RR$.
We apply the inequality \ref{answertoexer-focondsecond} with
the two points $\bx+ t(\by - \bx)$ and $\bx+ s(\by - \bx)$.
By the convexity of $C$, these points are in $C$ so that we get
\begin{eqnarray}
\left[\bg(\bx+ t(\by - \bx))-\bg(\bx+ s(\by - \bx))\right]^T 
(\bx+ t(\by - \bx) - \bx - s(\by - \bx ) \geq 0.
\end{eqnarray}
The left hand side can be simplified into $(t-s ) (\phi'(t) - \phi'(s)) \geq 0$.
For $t\geq s$, the previous inequality leads to \ref{anwsers-convexphiprime}.

We now integrate the inequality \ref{anwsers-convexphiprime} for 
$t\in[\theta,1]$ and $s\in[0,\theta]$ so that the order $t\geq s$ is satisfied
and we get
\begin{eqnarray}
\label{anwsers-convexphiprime-int}
\int_{t\in[\theta,1]} \int_{s\in[0,\theta]} \left( \phi'(t) - \phi'(s) \right) dt ds \geq 0.
\end{eqnarray}
We first compute the following two integrals 
\begin{eqnarray}
\int_{s\in[0,\theta]} \int_{t\in[\theta,1]} \phi'(t) dt ds 
&=& \int_{s\in[0,\theta]} (\phi(1)-\phi(\theta)) ds\\
&=& \theta (\phi(1)-\phi(\theta)),
\label{anwsers-convexphiprime-int1}
\end{eqnarray}
and 
\begin{eqnarray}
\int_{t\in[\theta,1]} \int_{s\in[0,\theta]} \phi'(s) ds dt 
&=& \int_{t\in[\theta,1]} (\phi(\theta) -\phi(0)) dt\\
&=& (1-\theta) (\phi(\theta) -\phi(0)).
\label{anwsers-convexphiprime-int2}
\end{eqnarray}
By plugging the two integrals \ref{anwsers-convexphiprime-int1} and \ref{anwsers-convexphiprime-int2}
into the inequality \ref{anwsers-convexphiprime-int}, we get
\begin{eqnarray}
\theta (\phi(1)-\phi(\theta)) - (1-\theta) (\phi(\theta) -\phi(0)) \geq 0,
\end{eqnarray}
which simplifies to 
\begin{eqnarray}
\theta \phi(1) + (1-\theta) \phi(0) -\phi(\theta) \geq 0.
\end{eqnarray}
which proves that $\phi$ is convex.
If we plug the definition \ref{answer-defphi} of $\phi$ and the 
equalities $\phi(0) = f(\bx)$ and $\phi(1) = f(\by)$, we find 
the convexity inequality for $f$
\begin{eqnarray}
\theta f(\by) + (1-\theta) f(\bx) \leq f(\theta \by + (1-\theta) \bx),
\end{eqnarray}
which concludes the proof. 
\end{answer}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{introoptim-exer-localconvexrosen}}{Hessian of Rosenbrock's function}
Let us prove that the Hessian matrix of Rosenbrock's function is positive definite 
at the point $\bx = (1,1)^T$.
In the following script, we define the point \scivar{x} and use the \scifun{rosenbrock}
function to compute the associated Hessian matrix. Then we use the \scifun{spec} function
in order to compute the eigenvalues. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->x = [1 1];
-->[ f , g , H ] = rosenbrock ( x );
-->D = spec ( H )
 D  =
    0.3993608  
    1001.6006
\end{lstlisting}
We see that both eigenvalues are strictly positive, although the second 
is much larger than the first in magnitude. Hence, the matrix $H(\bx)$ is 
positive definite for $\bx = (1,1)^T$.
Let us check that it is indefinite at the point $\bx = (0,1)^T$. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->x = [0 1];
-->[ f , g , H ] = rosenbrock ( x );
-->D = spec ( H )
 D  =
  - 398.  
    200.  
\end{lstlisting}
We now see that the first eigenvalue is negative while 
the second is positive. Hence, the matrix $H(\bx)$ is 
indefinite for $\bx = (0,1)^T$.
Let us make a random walk in the interval $[-2,2]\times[-1,2]$ and 
check that many points are associated with an indefinite Hessian matrix. 
In the following script, we use the \scifun{rand} function to perform a random
walk in the required interval. To make so that the script allways 
performs the same computation, we initialize the seed of the random 
number generator to zero. Then we define the lower and the upper bound 
of the simulation. Inside the loop, we generate a uniform random vector \scivar{t}
in the interval $[0,1]^2$ and scale it with the \scivar{low} and \scivar{upp} 
arrays in order to produce points in the target interval. We use particular 
formatting rules for the \scifun{mprintf} function in order to get the numbers
aligned. 
\lstset{language=scilabscript}
\begin{lstlisting}
rand("seed",0);
ntrials = 10;
low = [-2 -1]';
upp = [2 2]';
for it = 1 : ntrials
  t = rand(2,1);
  x = (upp - low) .* t + low;
  [ f , g , H ] = rosenbrock ( x );
  D = spec ( H );
  mprintf("(%3d) x=[%+5f %+5f], D =[%+7.1f %+7.1f]\n",..
    it,x(1),x(2),D(1),D(2))
end
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
(  1) x=[-1.154701 +1.268132], D =[   +4.4 +1290.4]
(  2) x=[-1.999115 -0.009019], D =[  +65.0 +4936.4]
(  3) x=[+0.661524 +0.885175], D =[  -78.4  +451.5]
(  4) x=[+1.398981 +1.057193], D =[  +34.6 +2093.1]
(  5) x=[+1.512866 -0.794878], D =[  +77.5 +3189.0]
(  6) x=[+0.243394 +0.987071], D =[ -339.3  +217.6]
(  7) x=[+0.905403 -0.404457], D =[  +77.4 +1270.1]
(  8) x=[+0.177029 -0.303776], D =[ +107.1  +254.0]
(  9) x=[-1.075105 -0.350610], D =[  +73.0 +1656.3]
( 10) x=[+1.533555 +0.957540], D =[  +43.1 +2598.0]
\end{lstlisting}
By increasing the number of trials, we see that the first eigenvalue is 
often negative.
\end{answer}

\end{footnotesize}

